# Debugging

1-Attitude  by Duaa  
2-General principles + visual inspection by Duaa  
3-Multimeter  by Henk  
4-Logical analyzers  by Henk  
5-Oscilloscope   by Henk  
6-How to debug almost anything kit by Henk  
7-Flashing your board by Quentin  
8- MCU debugging by Quentin  
9-Serial (or any) "Hello world!"  by Nicolas  
10-USB and computer detection  by Nicolas  
11 -Radio Communications   by Nicolas  

## presentation link   

[https://fabacademy.org/2022/recitation/Debugging/slides/index.html](https://fabacademy.org/2022/recitation/Debugging/slides/index.html) 

## General principles
Duaa 

Where to start 
How to narrow down the source of the problem
## Power check
  - Nothing : open circuit, short circuit, line break, blown fuse, ...
  - Voltage too low : power supply impedence, badly selected, ...
  - Voltage too high : above max. ratings, dead zener/reg., ...
  - GND/VCC loop

Constant => Multimeter.
Dynamic/"Random" effect => Oscilloscope.

## [Multimeter](https://3.bp.blogspot.com/-9AlLfYbaJus/VgnNMiq3afI/AAAAAAAACgM/eDy22x8fC8s/s1600/Digital%2Bmultimeter%2Bdial.jpg)
  - Continuity check (+diodes orientation) : [symbol](https://multimeterexpert.com/wp-content/uploads/2017/01/test-continuity-with-multimeter.png)
  - Voltage check : [parallel measurement](https://www.sciencebuddies.org/Files/4807/6/fig6_multimeter-parallel-measure-voltage.jpg)
  - Resistance / current / ... 

Be carefull with the cable connexions! (serial VS parallel measurements)

## Oscilloscope
[Nicolas & Duaa?]

  - "Real" levels
  - Dynamic view
  - 10MHz - >1GHz ranges
  - Few channels (~1-4)
  - Trigger/Time/Level
  - Expensive (comparatively to logical analyzers)

The poor man's solution : computer's microphone input. (~22KHz)


## Logical analyzers
[Henk & Nicolas?]
 - Only "logical levels" (0 : <0.6V - 1 : > 1.2V => not CMOS logic!)
 - Multiple channels (8-16...)
 - "Unexpensive"
 - Allows you to read complex protocols (usually computer-based operation)

## Serial (or any) "Hello world!"
  - Output "Hello world!" messages while your program is executing.
  - LED
  - Serial
  - Other

## USB and computer detection
    -lsusb
Nicolas & Fran?

## TNT for radiofreq?
https://www.gnuradio.org/

## Break point and variables observations
Nicolas can do it with PIC + microchip IDE but more than probably better with 
atmel / arm families => anybody?


## Reflow


## How to debug almost anything kit
Henk
